Index: /trunk/src/org/expeditee/io/PdfFramesetWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/PdfFramesetWriter.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/PdfFramesetWriter.java	(revision 1102)
@@ -19,7 +19,5 @@
 package org.expeditee.io;
 
-import java.awt.Dimension;
 import java.awt.Graphics2D;
-import java.awt.Image;
 import java.io.FileOutputStream;
 import java.io.IOException;
@@ -28,4 +26,11 @@
 import java.util.List;
 
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Image;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gio.swing.SwingConversions;
+import org.expeditee.gio.swing.SwingMiscManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameGraphics;
@@ -35,5 +40,5 @@
 import org.expeditee.items.Picture;
 import org.expeditee.items.Text;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.settings.UserSettings;
 
@@ -59,8 +64,8 @@
 	private boolean _showFrameNames;
 
-	public PdfFramesetWriter(long firstFrame, long maxFrame,
-			boolean showFrameNames) {
+	public PdfFramesetWriter(long firstFrame, long maxFrame, boolean showFrameNames)
+	{
 		super(firstFrame, maxFrame);
-		Dimension d = FrameGraphics.getMaxSize();
+		Dimension d = DisplayController.getFramePaintArea().getSize();
 		_pdfDocument = new Document(new Rectangle(d.width, d.height));
 		_showFrameNames = showFrameNames;
@@ -130,10 +135,11 @@
 		// we tell the ContentByte we're ready to draw text
 		cb.beginText();
-		Font font = FontFactory.getFont(
-				Conversion.getPdfFont(text.getFamily()), text.getSize(), text
-						.getPaintFont().getStyle(), text.getPaintColor());
+		Font font = FontFactory.getFont(Conversion.getPdfFont(text.getFamily()),
+										text.getSize(),
+										SwingConversions.toSwingFontStyle(text.getPaintFont().getStyle()),
+										SwingConversions.toSwingColor(text.getPaintColor()));
 		cb.setFontAndSize(font.getBaseFont(), text.getSize());
 		// cb.setColorStroke(text.getPaintColor());
-		cb.setColorFill(text.getPaintColor());
+		cb.setColorFill(SwingConversions.toSwingColor(text.getPaintColor()));
 
 		// we draw some text on a certain position
@@ -158,5 +164,5 @@
 			PdfContentByte cb = _pdfWriter.getDirectContent();
 			com.lowagie.text.Image iTextImage = com.lowagie.text.Image
-					.getInstance(image, null);
+					.getInstance(SwingMiscManager.getIfUsingSwingImageManager().getInternalImage(image), null);
 			iTextImage.setAbsolutePosition(pic.getX(), _pdfWriter.getPageSize()
 					.getHeight()
@@ -175,8 +181,10 @@
 //			cb.setColorFill(fill);
 //		}
-		Graphics2D g = cb.createGraphicsShapes(
+/*		Graphics2D g = cb.createGraphicsShapes(
 				FrameGraphics.getMaxSize().width,
-				FrameGraphics.getMaxSize().height);
-		lineEnd.paint(g);
+				FrameGraphics.getMaxSize().height);*/
+		GraphicsManager g = EcosystemManager.getGraphicsManager();
+		Image temp = EcosystemManager.getImageManager().createImage(DisplayController.getFramePaintArea().getSize());
+		lineEnd.paint();
 //		if (fill != null) {
 //			g.setPaint(fill);
@@ -191,20 +199,25 @@
 	
 	@Override
-	protected void writeCircle(Circle toWrite) throws IOException {
-		PdfContentByte cb = _pdfWriter.getDirectContent();
-		Graphics2D g = cb.createGraphicsShapes(
-				FrameGraphics.getMaxSize().width,
-				FrameGraphics.getMaxSize().height);
-		toWrite.paint(g);
+	protected void writeCircle(Circle toWrite) throws IOException
+	{
+		PdfContentByte cb = _pdfWriter.getDirectContent();
+		Graphics2D g = cb.createGraphicsShapes(DisplayController.getFramePaintArea().getWidth(), DisplayController.getFramePaintArea().getHeight());
+		Image temp = EcosystemManager.getImageManager().createImage(DisplayController.getFramePaintArea().getSize());
+		EcosystemManager.getGraphicsManager().pushDrawingSurface(temp);
+		toWrite.paint();
+		EcosystemManager.getGraphicsManager().popDrawingSurface();
+		g.drawImage(SwingMiscManager.getIfUsingSwingImageManager().getInternalImage(temp), 0, 0, null);
 	}
 	
-	
-	@Override
-	protected void writeWidget(InteractiveWidget toWrite) throws IOException {
-		PdfContentByte cb = _pdfWriter.getDirectContent();
-		Graphics2D g = cb.createGraphicsShapes(
-				FrameGraphics.getMaxSize().width,
-				FrameGraphics.getMaxSize().height);
-		toWrite.paint(g);
+	@Override
+	protected void writeWidget(Widget toWrite) throws IOException
+	{
+		PdfContentByte cb = _pdfWriter.getDirectContent();
+		Graphics2D g = cb.createGraphicsShapes(DisplayController.getFramePaintArea().getWidth(), DisplayController.getFramePaintArea().getHeight());
+		Image temp = EcosystemManager.getImageManager().createImage(DisplayController.getFramePaintArea().getSize());
+		EcosystemManager.getGraphicsManager().pushDrawingSurface(temp);
+		toWrite.paint();
+		EcosystemManager.getGraphicsManager().popDrawingSurface();
+		g.drawImage(SwingMiscManager.getIfUsingSwingImageManager().getInternalImage(temp), 0, 0, null);
 	}
 }
Index: /trunk/src/org/expeditee/io/ProxyAuth.java
===================================================================
--- /trunk/src/org/expeditee/io/ProxyAuth.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/ProxyAuth.java	(revision 1102)
@@ -24,4 +24,6 @@
 public class ProxyAuth extends Authenticator {
 
+	public static final int MAX_ATTEMPTS = 5;
+	
 	private String httpUser = null, httpPass = null, httpsUser = null, httpsPass = null;
 	private int attempts = 0;
@@ -37,5 +39,5 @@
 		// stop it from breaking from a redirect loop
 		attempts++;
-		if(attempts > 5) {
+		if(attempts > MAX_ATTEMPTS) {
 			return null;
 		}
Index: /trunk/src/org/expeditee/io/ProxyWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/ProxyWriter.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/ProxyWriter.java	(revision 1102)
@@ -19,10 +19,11 @@
 package org.expeditee.io;
 
-import java.awt.Toolkit;
-import java.awt.datatransfer.StringSelection;
 import java.io.BufferedWriter;
 import java.io.IOException;
 import java.io.PipedWriter;
 import java.io.Writer;
+
+import org.expeditee.gio.ClipboardManager.ClipboardData;
+import org.expeditee.gio.EcosystemManager;
 
 public class ProxyWriter extends BufferedWriter {
@@ -55,10 +56,8 @@
 	public void flush() throws IOException {
 		if (_contents != null) {
-			StringSelection selection = new StringSelection(_contents
-					.toString());
-			Toolkit.getDefaultToolkit().getSystemClipboard().setContents(
-					selection, null);
-		} else
+			EcosystemManager.getClipboardManager().set(ClipboardData.fromString(_contents.toString()));
+		} else {
 			super.flush();
+		}
 	}
 
Index: /trunk/src/org/expeditee/io/StreamGobbler.java
===================================================================
--- /trunk/src/org/expeditee/io/StreamGobbler.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/StreamGobbler.java	(revision 1102)
@@ -19,9 +19,5 @@
 package org.expeditee.io;
 
-
-import java.util.*;
 import java.io.*;
-
-import javax.swing.SwingUtilities;
 
 import org.expeditee.gui.MessageBay;
@@ -82,5 +78,5 @@
             	// MessageBay is on the AWT event thread, so need to use 'invokeLater' to avoid thread deadlock
             	Runnable updateMessageBayTask = new UpdateMessageBay(type,line);
-                SwingUtilities.invokeLater(updateMessageBayTask);
+                updateMessageBayTask.run();
             	
             }
Index: /trunk/src/org/expeditee/io/WebParser.java
===================================================================
--- /trunk/src/org/expeditee/io/WebParser.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/WebParser.java	(revision 1102)
@@ -19,7 +19,4 @@
 package org.expeditee.io;
 
-import java.awt.Color;
-import java.awt.Font;
-import java.awt.image.BufferedImage;
 import java.io.File;
 import java.io.IOException;
@@ -45,5 +42,4 @@
 import javafx.beans.value.ObservableValue;
 import javafx.concurrent.Worker.State;
-import javafx.embed.swing.SwingFXUtils;
 import javafx.scene.SnapshotParameters;
 import javafx.scene.image.WritableImage;
@@ -51,13 +47,16 @@
 import javafx.scene.web.WebView;
 
-import javax.imageio.ImageIO;
-
 import netscape.javascript.JSObject;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Font;
+import org.expeditee.core.Image;
+import org.expeditee.core.InOutReference;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gio.swing.SwingMiscManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FrameUtils;
 import org.expeditee.gui.MessageBay;
@@ -303,6 +302,6 @@
 		try {
 			
-			final int verticalScrollPerPage = (int) (FrameGraphics.getMaxFrameSize().getHeight() * 0.85);
-			final int horizontalScrollPerPage = (int) (FrameGraphics.getMaxFrameSize().getWidth() * 0.85);
+			final int verticalScrollPerPage = (int) (DisplayController.getFramePaintArea().getHeight() * 0.85);
+			final int horizontalScrollPerPage = (int) (DisplayController.getFramePaintArea().getWidth() * 0.85);
 						
 			Platform.runLater(new Runnable() {
@@ -320,9 +319,9 @@
 			final Object notifier = new Object();
 						
-			final MutableInt verticalCount = new MutableInt(0);
-			final MutableInt horizontalCount = new MutableInt(0);
+			final InOutReference<Integer> verticalCount = new InOutReference<Integer>(0);
+			final InOutReference<Integer> horizontalCount = new InOutReference<Integer>(0);
 			
-			final MutableInt pagesVertical = new MutableInt(1);
-			final MutableInt pagesHorizontal = new MutableInt(1);
+			final InOutReference<Integer> pagesVertical = new InOutReference<Integer>(1);
+			final InOutReference<Integer> pagesHorizontal = new InOutReference<Integer>(1);
 
 			final String pageTitle;
@@ -341,10 +340,10 @@
 			frameset.getTitleItem().setSize(14);
 
-			WebParser.addButton("Return to original frame", frame.getName(), null, 200, frameset, null, 0f, 10f, null);
-
-			Text link = DisplayIO.getCurrentFrame().addText(FrameMouseActions.getX(), FrameMouseActions.getY(), pageTitle, null);
+			WebParser.addButton("Return to original frame", frame.getName(), null, 200, frameset, null, 0, 10, null);
+
+			Text link = DisplayController.getCurrentFrame().addText(DisplayController.getMouseX(), DisplayController.getMouseY(), pageTitle, null);
 			link.setLink(frameset.getName());
 
-			FrameMouseActions.pickup(link);
+			StandardGestureActions.pickup(link);
 
 			// Timer that fires every time JFX is redrawn. After a few redraws, the handle method of this takes a screenshot of the page,
@@ -364,5 +363,5 @@
 						this.stop();
 						
-						verticalCount.setValue(verticalCount.getValue() + 1);
+						verticalCount.set(verticalCount.get() + 1);
 
 						frameToAddTo = FrameIO.CreateFrame(frameToAddTo.getFramesetName(), pageTitle, null);
@@ -395,12 +394,15 @@
 
 						// Getting a BufferedImage from the JavaFX image
-						BufferedImage image = SwingFXUtils.fromFXImage(img, null);
+						//BufferedImage image = SwingFXUtils.fromFXImage(img, null);
+						Image image = SwingMiscManager.getImageForJavaFXImage(img);
 
 						try {
-							int hashcode = Arrays.hashCode(image.getData().getPixels(0, 0, image.getWidth(), image.getHeight(), (int[]) null));
-
+							// TODO: tidy. cts16
+							//int hashcode = Arrays.hashCode(image.getData().getPixels(0, 0, image.getWidth(), image.getHeight(), (int[]) null));
+							int hashcode = image.hashCode();
+							
 							File out = new File(FrameIO.IMAGES_PATH + "webpage-" + Integer.toHexString(hashcode) + ".png");
 							out.mkdirs();
-							ImageIO.write(image, "png", out);
+							image.writeToDisk("png", out);
 
 							// Adding the image to the frame
@@ -408,23 +410,23 @@
 							
 							// Adding thumbnail to the overview page
-							Text thumb = frameset.addText((int) (thumbWidth * 1.1 * horizontalCount.getValue()) + 10,
-									(int) ((((float) thumbWidth / image.getWidth()) * image.getHeight()) * 1.1 * verticalCount.getValue()),
+							Text thumb = frameset.addText((int) (thumbWidth * 1.1 * horizontalCount.get()) + 10,
+									(int) ((((float) thumbWidth / image.getWidth()) * image.getHeight()) * 1.1 * verticalCount.get()),
 									"@i: " + out.getName() + " " + thumbWidth, 
 									null);
 							
 							thumb.setLink(frameToAddTo.getName());
-							thumb.setBorderColor(Color.lightGray);
+							thumb.setBorderColor(Colour.LIGHT_GREY);
 							thumb.setThickness(1);
 
 							// Button to go to the next frame/page
-							WebParser.addButton("Next", null, "next", 70, frameToAddTo, null, 0f, 10f, null);
+							WebParser.addButton("Next", null, "next", 70, frameToAddTo, null, 0, 10, null);
 
 							// Button to go to the previous frame/page
-							if (verticalCount.getValue() > 1 || horizontalCount.getValue() > 0) {
-								WebParser.addButton("Previous", null, "previous", 70, frameToAddTo, null, 85f, 10f, null);
+							if (verticalCount.get() > 1 || horizontalCount.get() > 0) {
+								WebParser.addButton("Previous", null, "previous", 70, frameToAddTo, null, 85, 10, null);
 							}
 
 							// Button to return to the index/overview page
-							WebParser.addButton("Index", frameset.getName(), null, 70, frameToAddTo, null, null, 10f, 5f);
+							WebParser.addButton("Index", frameset.getName(), null, 70, frameToAddTo, null, null, 10, 5);
 
 							FrameIO.SaveFrame(frameToAddTo);
@@ -435,5 +437,5 @@
 						}
 
-						image.flush();
+						image.releaseImage();
 
 						synchronized (notifier) {
@@ -468,13 +470,13 @@
 						// but if the webpage fits in a single converted page, there's no need for any overlap, so just use 1 as the number of pages
 						if((Boolean) webEngine.executeScript("document.documentElement.scrollHeight > window.innerHeight")) {
-							pagesVertical.setValue((int) Math.ceil((Integer) webEngine.executeScript("document.documentElement.scrollHeight") / (float) verticalScrollPerPage));
+							pagesVertical.set((int) Math.ceil((Integer) webEngine.executeScript("document.documentElement.scrollHeight") / (float) verticalScrollPerPage));
 						}
 						
 						if((Boolean) webEngine.executeScript("document.documentElement.scrollWidth > window.innerWidth")) {
-							pagesHorizontal.setValue((int) Math.ceil((Integer) webEngine.executeScript("document.documentElement.scrollWidth") / (float) horizontalScrollPerPage));
+							pagesHorizontal.set((int) Math.ceil((Integer) webEngine.executeScript("document.documentElement.scrollWidth") / (float) horizontalScrollPerPage));
 						}
 						
 						System.out.println(webEngine.executeScript("document.documentElement.scrollWidth") + "/" + horizontalScrollPerPage);
-						System.out.println(pagesVertical.getValue() + "x" + pagesHorizontal.getValue());
+						System.out.println(pagesVertical.get() + "x" + pagesHorizontal.get());
 						
 						// Setting up the element that contains the CSS to hide all text. Also hiding readability mode buttons.
@@ -628,5 +630,5 @@
 
 			// Loop that scrolls the page horizontally
-			for(int i = 0; i < pagesHorizontal.getValue() && browserWidget.isParserRunning(); i++) {
+			for(int i = 0; i < pagesHorizontal.get() && browserWidget.isParserRunning(); i++) {
 								
 				Platform.runLater(new Runnable() {
@@ -647,8 +649,8 @@
 				
 				// Loop that scrolls the page vertically (for each horizontal scroll position)
-				for(int j = 0; j < pagesVertical.getValue()  && browserWidget.isParserRunning(); j++) {
+				for(int j = 0; j < pagesVertical.get()  && browserWidget.isParserRunning(); j++) {
 					
 					try {
-						progressBar.set((int) (50 + ((float)(j+1)/(pagesVertical.getValue() * pagesHorizontal.getValue())  + ((float)(i) / pagesHorizontal.getValue())) * 50));
+						progressBar.set((int) (50 + ((float)(j+1)/(pagesVertical.get() * pagesHorizontal.get())  + ((float)(i) / pagesHorizontal.get())) * 50));
 					} catch (Exception e) {
 						e.printStackTrace();
@@ -698,6 +700,6 @@
 				}
 
-				horizontalCount.setValue(horizontalCount.getValue() + 1);
-				verticalCount.setValue(0);
+				horizontalCount.set(horizontalCount.get() + 1);
+				verticalCount.set(0);
 			}
 
@@ -742,5 +744,5 @@
 	 * @return A Color object that should match the rgb string passed int. Returns null if alpha is 0
 	 */
-	private static Color rgbStringToColor(String rgbString) {
+	private static Colour rgbStringToColor(String rgbString) {
 
 		if (rgbString == null) {
@@ -764,5 +766,5 @@
 
 		if (components[3] > 0) {
-			return new Color(components[0], components[1], components[2], components[3]);
+			return Colour.FromRGBA255(components[0], components[1], components[2], components[3]);
 		} else {
 			return null;
@@ -854,5 +856,5 @@
 
 					Boolean fontFound = false;
-					Font font = new Font(null);
+					Font font = null;
 
 					// Looping through all font-families listed in the element's CSS until one that is installed is
@@ -869,14 +871,19 @@
 						
 						// Regex will remove any inverted commas surrounding multi-word typeface names
-						font = new Font(typefaces[j].replaceAll("^'|'$", ""), Font.PLAIN, 12);
-						
-						// If the font isn't found, Java just uses Font.DIALOG, so this check checks whether the font was found
-						if (!(font.getFamily().toLowerCase().equals(Font.DIALOG.toLowerCase()))) {
+						String familyName = typefaces[j].replaceAll("^'|'$", "");
+						font = new Font(familyName);
+						font.setStyle(Font.Style.PLAIN);
+						font.setSize(12);
+						
+						// Check whether the font was found
+						if (EcosystemManager.getFontManager().getActualFont(font).getFamilyName().toLowerCase().equals(familyName.toLowerCase())) {
 							fontFound = true;
 						}
 					}
 
-					if (font.getFamily().toLowerCase().equals(Font.DIALOG.toLowerCase())) {
-						font = new Font("Times New Roman", Font.PLAIN, 12);
+					if (!fontFound) {
+						font = new Font("Times New Roman");
+						font.setStyle(Font.Style.PLAIN);
+						font.setSize(12);
 					}
 
@@ -975,5 +982,5 @@
 					String bgColorString = (String) style.call("getPropertyValue", new Object[] { "background-color" });
 
-					Color bgColor = rgbStringToColor(bgColorString);
+					Colour bgColor = rgbStringToColor(bgColorString);
 
 					// If the element has a background color then add it (to Expeditee) as a rectangle with that background color
@@ -1077,13 +1084,11 @@
 		HttpURLConnection connection = (HttpURLConnection) (imgUrl.openConnection());
 
-		// Spoofing a widely accepted User Agent, since some sites refuse to serve non-webbrowser clients
-		connection.setRequestProperty("User-Agent", "Mozilla/5.0");
-
-		BufferedImage img = ImageIO.read(connection.getInputStream());
-
-		int hashcode = Arrays.hashCode(img.getData().getPixels(0, 0, img.getWidth(), img.getHeight(), (int[]) null));
+		Image img = Image.getImage(connection);
+		
+		int hashcode = img.hashCode();
+		
 		File out = new File(FrameIO.IMAGES_PATH + Integer.toHexString(hashcode) + ".png");
 		out.mkdirs();
-		ImageIO.write(img, "png", out);
+		img.writeToDisk("png", out);
 
 		if (repeat == null && cropEndX == null && cropStartX == null && cropEndY == null && cropStartY == null) {
@@ -1153,5 +1158,5 @@
 		text.setPosition(x, y);
 
-		Picture pic = ItemUtils.CreatePicture(text, frame);
+		Picture pic = ItemUtils.CreatePicture(text);
 		
 		float invScale = 1 / pic.getScale();
@@ -1324,5 +1329,5 @@
 
 				Boolean fontFound = false;
-				Font font = new Font(null);
+				Font font = null;
 
 				// Looping through all font-families listed in the element's CSS until one that is installed is
@@ -1342,14 +1347,19 @@
 
 					// Regex will remove any inverted commas surrounding multi-word typeface names
-					font = new Font(typefaces[j].replaceAll("^'|'$", ""), Font.PLAIN, 12);
+					String familyName = typefaces[j].replaceAll("^'|'$", "");
+					font = new Font(familyName);
+					font.setStyle(Font.Style.PLAIN);
+					font.setSize(12);
 
 					// If the font isn't found, Java just uses Font.DIALOG, so this check checks whether the font was found
-					if (!(font.getFamily().toLowerCase().equals(Font.DIALOG.toLowerCase()))) {
+					if (EcosystemManager.getFontManager().getActualFont(font).getFamilyName().toLowerCase().equals(familyName.toLowerCase())) {
 						fontFound = true;
 					}
 				}
 
-				if (font.getFamily().toLowerCase().equals(Font.DIALOG.toLowerCase())) {
-					font = new Font("Times New Roman", Font.PLAIN, 12);
+				if (!fontFound) {
+					font = new Font("Times New Roman");
+					font.setStyle(Font.Style.PLAIN);
+					font.setSize(12);
 				}
 
@@ -1464,5 +1474,5 @@
 	 * @param anchorLeft
 	 */
-	private static void addButton(String text, String link, String action, int width, Frame toAddTo, Float anchorTop, Float anchorRight, Float anchorBottom, Float anchorLeft) {
+	private static void addButton(String text, String link, String action, int width, Frame toAddTo, Integer anchorTop, Integer anchorRight, Integer anchorBottom, Integer anchorLeft) {
 		// Button to go to the next frame/page
 		Text button = new Text(text);
@@ -1470,6 +1480,6 @@
 		button.setLink(link);
 		button.addAction(action);
-		button.setBorderColor(new Color(0.7f, 0.7f, 0.7f));
-		button.setBackgroundColor(new Color(0.9f, 0.9f, 0.9f));
+		button.setBorderColor(new Colour(0.7f, 0.7f, 0.7f));
+		button.setBackgroundColor(new Colour(0.9f, 0.9f, 0.9f));
 		button.setThickness(1);
 		button.setLinkMark(false);
@@ -1499,36 +1509,3 @@
 
 	}
-
-
-	private static class MutableBool {
-		private boolean value;
-
-		public MutableBool(boolean value) {
-			this.value = value;
-		}
-
-		public boolean getValue() {
-			return value;
-		}
-
-		public void setValue(boolean value) {
-			this.value = value;
-		}
-	}
-
-	private static class MutableInt {
-		private int value;
-
-		public MutableInt(int value) {
-			this.value = value;
-		}
-
-		public int getValue() {
-			return value;
-		}
-
-		public void setValue(int value) {
-			this.value = value;
-		}
-	}
 }
Index: /trunk/src/org/expeditee/io/flowlayout/DimensionExtent.java
===================================================================
--- /trunk/src/org/expeditee/io/flowlayout/DimensionExtent.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/flowlayout/DimensionExtent.java	(revision 1102)
@@ -19,9 +19,8 @@
 package org.expeditee.io.flowlayout;
 
-import java.awt.Polygon;
-import java.awt.Rectangle;
-import java.awt.geom.Area;
 import java.util.List;
 
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.core.bounds.PolygonBounds;
 import org.expeditee.items.Item;
 
@@ -44,8 +43,7 @@
 		
 		for (Item item : items) {
-			Area area = item.getArea();
-			Rectangle rect = area.getBounds();
-			int xl = rect.x;
-			int xr = xl + rect.width-1;
+			AxisAlignedBoxBounds bounds = item.getBoundingBox();
+			int xl = bounds.getMinX();
+			int xr = xl + bounds.getWidth()-1;
 			
 			min_x = Math.min(min_x, xl);
@@ -66,8 +64,7 @@
 		
 		for (Item item : items) {
-			Area area = item.getArea();
-			Rectangle rect = area.getBounds();
-			int yt = rect.y;
-			int yb = yt + rect.height-1;
+			AxisAlignedBoxBounds bounds = item.getBoundingBox();
+			int yt = bounds.getMinY();
+			int yb = yt + bounds.getHeight()-1;
 			
 			min_y = Math.min(min_y, yt);
@@ -82,63 +79,33 @@
 
 	
-	public static DimensionExtent calcMinMaxXExtent(Polygon polygon)
+	public static DimensionExtent calcMinMaxXExtent(PolygonBounds polygon)
 	{
 
-		int min_x = Integer.MAX_VALUE;
-		int max_x = Integer.MIN_VALUE;
-		
-		int npoints = polygon.npoints;
-
-		for (int i=0; i<npoints; i++) {
-
-			int x = polygon.xpoints[i];
-
-			min_x = Math.min(min_x, x);
-			max_x = Math.max(max_x, x);
-		}
-		
-		DimensionExtent extent = new DimensionExtent(min_x,max_x);
+		DimensionExtent extent = new DimensionExtent(polygon.getMinX(), polygon.getMaxX());
 		
 		return extent;
 	}
 	
-	public static DimensionExtent calcMinMaxYExtent(Polygon polygon)
+	public static DimensionExtent calcMinMaxYExtent(PolygonBounds polygon)
 	{
 
-		int min_y = Integer.MAX_VALUE;
-		int max_y = Integer.MIN_VALUE;
-		
-		int npoints = polygon.npoints;
-		
-		for (int i=0; i<npoints; i++) {
-
-			int y = polygon.ypoints[i];
-				
-			min_y = Math.min(min_y, y);
-			max_y = Math.max(max_y, y);
-		}
-		
-		DimensionExtent extent = new DimensionExtent(min_y,max_y);
+		DimensionExtent extent = new DimensionExtent(polygon.getMinY(), polygon.getMaxY());
 		
 		return extent;
 	}
 	
-	public static Polygon boundingBoxPolygon(List<Item> items)
+	public static PolygonBounds boundingBoxPolygon(List<Item> items)
 	{
-		DimensionExtent xextent = DimensionExtent.calcMinMaxXExtent(items);
-		DimensionExtent yextent = DimensionExtent.calcMinMaxYExtent(items);
-	
-		int xl=xextent.min;
-		int xr=xextent.max;
-		int yt=yextent.min;
-		int yb=yextent.max;
+		AxisAlignedBoxBounds box = null;
 		
-		int[] xpoints = new int[]{xl,xr,xr,xl};
-		int[] ypoints = new int[]{yt,yt,yb,yb};
+		for (Item i : items) {
+			if (box == null) {
+				box = i.getBoundingBox();
+			} else {
+				box.combineWith(i.getBoundingBox());
+			}
+		}
 		
-		
-		Polygon polygon = new Polygon(xpoints,ypoints,4);
-		
-		return polygon;
+		return new PolygonBounds(box.getBorderLines());
 	}
 }
